﻿using HardwareShopContracts.BindingModels;
using HardwareShopContracts.SearchModels;
using HardwareShopContracts.ViewModels;
using HardwareShopDatabaseImplement;
using Microsoft.EntityFrameworkCore;

namespace HardwareShopContracts.StoragesContracts
{
    public class BuildStorage : IBuildStorage
    {
        public List<BuildViewModel> GetFullList()
        {
            using var context = new HardwareShopDatabase();
            return context.Builds
                    .Include(x => x.Components)
                    .ThenInclude(x => x.Component)
                    .Include(x => x.Comments)
                    .ToList()
                    .Select(x => x.GetViewModel)
                    .ToList();
        }

        public List<BuildViewModel> GetFilteredList(UserSearchModel model)
        {
            if (model.Id.HasValue)
            {
                return new();
            }
            using var context = new HardwareShopDatabase();
            return context.Builds
                    .Include(x => x.Components)
                    .ThenInclude(x => x.Component)
                    .Include(x => x.Comments)
                    .Where(x => x.UserId == model.Id)
                    .ToList()
                    .Select(x => x.GetViewModel)
                    .ToList();
        }

        public BuildViewModel? GetElement(BuildSearchModel model)
        {
            throw new NotImplementedException();
        }

        public BuildViewModel? Insert(BuildBindingModel model)
        {
            throw new NotImplementedException();
        }

        public BuildViewModel? Update(BuildBindingModel model)
        {
            throw new NotImplementedException();
        }

        public BuildViewModel? Delete(BuildBindingModel model)
        {
            throw new NotImplementedException();
        }
    }
}